# Installation prerequisites

We encourage to work in the Docker image provided at ```.gitlab/ci/builder.Dockerfile```. If this is not your preferred method then follow the steps described here.

This part of the guide is meant to describe prerequisites for the
installation of the L1CE that may non be explicitely covered
elsewere. They are mostly important if you want to run your own test instance in a custom host.

If you have troubles running the L1CE, please check that all the steps here are covered.

As a baseline the docker image at ```.gitlab/ci/builder.Dockerfile``` shows what is required to run L1CE.

## Dependencies

As first, all the dependencies must be installed in the host where the L1CE will run.

### Oracle 19.3

The required packages are the Oracle 19.3 packages at:

* [oracle-instantclient19.3-basic-19.3.0.0.0-2.x86_64.rpm](http://linuxsoft.cern.ch/cern/centos/7/cernonly/x86_64/Packages/oracle-instantclient19.3-basic-19.3.0.0.0-2.x86_64.rpm)
* [oracle-instantclient19.3-devel-19.3.0.0.0-1.x86_64.rpm](http://linuxsoft.cern.ch/cern/centos/7/cernonly/x86_64/Packages/oracle-instantclient19.3-devel-19.3.0.0.0-1.x86_64.rpm)
* [oracle-instantclient19.3-sqlplus-19.3.0.0.0-1.x86_64.rpm](http://linuxsoft.cern.ch/cern/centos/7/cernonly/x86_64/Packages/oracle-instantclient19.3-sqlplus-19.3.0.0.0-1.x86_64.rpm)

Download the [```tnsnames.ora```](http://service-oracle-tnsnames.web.cern.ch/service-oracle-tnsnames/tnsnames.ora) file from [here](http://service-oracle-tnsnames.web.cern.ch/service-oracle-tnsnames/tnsnames.ora) and copy it in ```/etc/```

### Node 12

Install Node 12 by firsly installing the RPM repo:

```bash
curl -sL https://rpm.nodesource.com/setup_12.x | sudo bash -
sudo yum install nodejs 
```

### Openssl

Also ```openssl``` is required:

```bash
sudo yum install openssl
```

### Disable SELinux (maybe?)

SELinux needs (maybe?) to be disabled. So edit the SELinux config file
`/etc/sysconfig/selinux` and set:


```
SELINUX=permissive
```

then disable it:

```
sudo setenforce 0
```

Finally, the firewall need to be also disabled:

```
sudo service firewalld stop
sudo systemctl disable firewalld
```

## Registering a new host with CERN SSO

You will need this step in order to access the DB to write data, which requires authentication.
Go to the [CERN applications portal](https://application-portal.web.cern.ch/) to register a new application.
Add a new application with the following settings:

* *Application Identifier*: Can be anything, but must be unique, ex: `l1ce-dev`
* *Name*: your favourite name to display
* *Homepage*: http://myhostname.cern.ch, ex: `http://l1ce-dev.cern.ch`
* *Description*: self-explaining
* *Administrators*: None
* *Managed by*: None
* *Category*: Official (probably personal or test works too)

After submitting, add an SSO to the SSO Registration tab with **OpenID Connect (OIDC)** type. Use ```http://myhostname.cern.ch/*```, e.g. ```http://l1ce-dev.cern.ch/*```, as redirect URI.
Take note of the **Client ID** and **Client Secret** generated by this process, you will need it later.